## drbd-9.0.30~1+git.8e9c0812.tar.bz2

=== Makefile ===
# Makefile for drbd
#
# This file is part of DRBD by Philipp Reisner and Lars Ellenberg.
#
# Copyright (C) 2001-2008, LINBIT Information Technologies GmbH.
# Copyright (C) 2001-2008, Philipp Reisner <philipp.reisner@linbit.com>.
# Copyright (C) 2002-2008, Lars Ellenberg <lars.ellenberg@linbit.com>.
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

GIT = git
LN_S = ln -s
RPMBUILD = rpmbuild
DEBBUILD = debuild

DOCKERREGISTRY := drbd.io
ARCH ?= amd64
ifneq ($(strip $(ARCH)),)
DOCKERREGISTRY := $(DOCKERREGISTRY)/$(ARCH)
endif
DOCKERREGPATH_RHEL7 = $(DOCKERREGISTRY)/drbd9-rhel7
DOCKERREGPATH_RHEL8 = $(DOCKERREGISTRY)/drbd9-rhel8
DOCKERREGPATH_BIONIC = $(DOCKERREGISTRY)/drbd9-bionic
DOCKERREGPATH_FOCAL = $(DOCKERREGISTRY)/drbd9-focal
DOCKERREGPATH_SLES15SP1 = $(DOCKERREGISTRY)/drbd9-sles15sp1

# Use the SPAAS (spatch as a service) online service
# Have this as make variable for distributions.
SPAAS ?= true

# default for KDIR/KVER
ifndef KVER
 ifndef KDIR
KVER = `uname -r`
KDIR = /lib/modules/$(KVER)/build
 else
# Aand sles is more special than rhel this time.
# Others may be even more special than those two :-/
# Try "kernelrelease" first, then try "kernelversion".
# If the magic does not work out for you,
# explicitly set both KVER and KDIR to matching values.
# M=... set to hopefully avoid write-permission problems
# during cc-option test and similar
KVER := $(shell (make -s -C $(KDIR) M=$(PWD)/drbd kernelrelease || make -s -C $(KDIR) M=$(PWD)/drbd kernelversion) | tail -n1)
ifeq ($(KVER),)
	$(error could not guess kernel version string from kernel sources at "$(KDIR)")
endif
 endif
endif
KDIR ?= /lib/modules/$(KVER)/build

# for some reason some of the commands below only work correctly in bash,
# and not in e.g. dash. I'm too lazy to fix it to be compatible.
SHELL=/bin/bash

SUBDIRS     = drbd

REL_VERSION := $(shell sed -ne '/^\#define REL_VERSION/{s/^[^"]*"\([^ "]*\).*/\1/;p;q;}' drbd/linux/drbd_config.h)
override GITHEAD := $(shell test -e .git && $(GIT) rev-parse HEAD)

# container image version tag. 'TAG', becasue we have this (too) generic name in other projects already
TAG ?= v$(REL_VERSION)

ifdef FORCE
#
# NOTE to generate a tgz even if too lazy to update the changelogs,
# or to forcefully include the FIXME to be done: latest change date;
# for now, include the git hash of the latest commit
# in the tgz name:
#   make distclean tgz FORCE=1
#
REL_VERSION := $(REL_VERSION)-$(GITHEAD)
endif

DIST_VERSION := $(REL_VERSION)
ifeq ($(subst -,_,$(DIST_VERSION)),$(DIST_VERSION))
    DIST_VERSION := $(DIST_VERSION)-1
endif
FDIST_VERSION := $(shell test -s .filelist && sed -ne 's,^drbd-\([^/]*\)/.*,\1,p;q' < .filelist)
ifeq ($(FDIST_VERSION),)
FDIST_VERSION := $(DIST_VERSION)
endif

all: module tools

.PHONY: all tools module
tools: | $(if $(filter module all,$(if $(MAKECMDGOALS),,all)),module)
	@cat README.drbd-utils
doc:
	@echo "Man page sources moved to https://github.com/LINBIT/drbd-utils/"

# we cannot use 'git submodule foreach':
# foreach only works if submodule already checked out
.PHONY: check-submods
check-submods:
	@if test -d .git && test -s .gitmodules; then \
		for d in `grep "^\[submodule" .gitmodules | cut -f2 -d'"'`; do \
			if [ ! "`ls -A $$d`" ]; then \
				git submodule init; \
				git submodule update; \
				break; \
			fi; \
		done; \
	fi

.PHONY: check-kdir
check-kdir:
	@if ! test -e $(KDIR)/Makefile ; then \
		echo "    SORRY, kernel makefile not found." ;\
	        echo "    You need to tell me a correct KDIR," ;\
	        echo "    Or install the neccessary kernel source packages." ;\
	        echo "" ;\
		false;\
	fi

.PHONY: module
module: check-kdir check-submods
	@ $(MAKE) -C drbd KVER=$(KVER) KDIR=$(KDIR) SPAAS=$(SPAAS)
	@ echo -e "\n\tModule build was successful."

install:
	$(MAKE) -C drbd install

unpatch:
	$(MAKE) -C drbd unpatch

clean: unpatch
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done
	rm -f *~

distclean: unpatch
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i distclean; done
	rm -f *~ .filelist

uninstall:
	@ set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i uninstall; done

.PHONY: check check_changelogs_up2date install uninstall distclean clean unpatch
check check_changelogs_up2date:
	@ up2date=true; dver_re=$(DIST_VERSION); dver_re=$${dver_re//./\\.};	\
	dver=$${dver_re%[-~]*}; 						\
	drel="$${dver_re#"$$dver"}"; drel="$${drel#[-~]}"; 			\
	drel="$${drel#0}"; 							\
	test -z "$$drel" && drel=1 && dver_re=$$dver_re"\(-1\| \|$$\)"; 	\
	echo "checking for presence of $$dver_re in various changelog files"; 	\
	for f in drbd-kernel.spec ; do 						\
	v=$$(sed -ne 's/^Version: //p' $$f); 					\
	r=$$(sed -ne 's/^Release: //p' $$f); 					\
	if ! printf "%s-%s" "$$v" "$$r" | grep -H --label $$f "$$dver_re\>"; then \
	   printf "\n\t%s Version/Release: tags need update\n" $$f; 		\
	   grep -Hn "^Version: " $$f ; 						\
	   up2date=false; fi ; 							\
	   in_changelog=$$(sed -n -e '0,/^%changelog/d' 			\
			     -e '/- '"$$dver_re"'\>/p' < $$f) ; 		\
	   if test -z "$$in_changelog" ; then 					\
	   printf "\n\t%%changelog in %s needs update\n" $$f; 			\
	   grep -Hn "^%changelog" $$f ; 					\
	   up2date=false; fi; 							\
	done ; 									\
	if ! grep -H "^\($$dver_re\|$$dver\) (api:" ChangeLog; 			\
	then 									\
	   printf "\nChangeLog:3:\tneeds update\n"; 				\
	   up2date=false; fi ; 							\
	for df in 7 8 ; do							\
	if ! grep "^ENV DRBD_VERSION $$dver" docker/Dockerfile.centos$$df ;	\
	then 									\
		printf "\nDockerfile.centos$$df: needs update\n"; 		\
	   up2date=false; fi ; 							\
	done ;									\
	if test -e debian/changelog 						\
	&& ! grep -H "^drbd ($$dver\(+linbit\)\?[-~]$$drel" debian/changelog; \
	then 									\
	   printf "\n\tdebian/changelog:1: needs update\n"; 			\
	   up2date=false; fi ; 							\
	$$up2date

.PHONY: drbd/.drbd_git_revision
ifdef GITHEAD
override GITDIFF := $(shell $(GIT) diff --name-only HEAD 2>/dev/null |	\
			tr -s '\t\n' '  ' |		\
			sed -e 's/^/ /;s/ *$$//')
drbd/.drbd_git_revision:
	@echo GIT-hash: $(GITHEAD)$(GITDIFF) > $@
else
drbd/.drbd_git_revision:
	@echo >&2 "Need a git checkout to regenerate $@"; test -s $@
endif

# update of .filelist is forced:
.PHONY: .filelist
.filelist:
	@set -e ; submodules=`$(GIT) submodule foreach --quiet 'echo $$path'`; \
	$(GIT) ls-files | \
	  grep -vxF -e "$$submodules" | \
	  grep -v "^\.gitlab" | \
	  sed '$(if $(PRESERVE_DEBIAN),,/^debian/d);s#^#drbd-$(DIST_VERSION)/#' | \
	  grep -v "gitignore\|gitmodules" > .filelist
	@$(GIT) submodule foreach --quiet 'git ls-files | sed -e "s,^,drbd-$(DIST_VERSION)/$$path/,"' | \
	  grep -v "gitignore\|gitmodules" >> .filelist
	@mkdir -p drbd/drbd-kernel-compat/cocci_cache/
	@find drbd/drbd-kernel-compat/cocci_cache/ -type f -not -path '*/\.*' | \
	 sed -e 's,^,drbd-$(DIST_VERSION)/,' >> .filelist
	@[ -s .filelist ] # assert there is something in .filelist now
	@echo drbd-$(DIST_VERSION)/.filelist               >> .filelist ; \
	echo drbd-$(DIST_VERSION)/drbd/.drbd_git_revision >> .filelist ; \
	echo "./.filelist updated."

# tgz will no longer automatically update .filelist,
# so the tgz and therefore rpm target will work within
# an extracted tarball, too.
# to generate a distribution tarball, use make tarball,
# which will regenerate .filelist
tgz:
	test -s .filelist
	rm -f drbd-$(FDIST_VERSION)
	$(LN_S) . drbd-$(FDIST_VERSION)
	for f in $$(<.filelist) ; do [ -e $$f ] && continue ; echo missing: $$f ; exit 1; done
	tar --owner=0 --group=0 -czf - -T .filelist > drbd-$(FDIST_VERSION).tar.gz
	rm drbd-$(FDIST_VERSION)

ifeq ($(FORCE),)
tgz: check_changelogs_up2date
endif

check_all_committed: unpatch
	@$(if $(FORCE),-,)modified=`$(GIT) diff --name-status HEAD`; 	\
	if test -n "$$modified" ; then	\
		echo "$$modified";	\
	       	false;			\
	fi

.PHONY: prepare_release
prepare_release:
	$(MAKE) tarball

.PHONY: release
release:
	$(MAKE) tarball

.PHONY: debrelease
debrelease:
	cd drbd/drbd-kernel-compat && bash collect_compat_h.sh
	$(MAKE) -C drbd compat
	$(MAKE) tarball PRESERVE_DEBIAN=1

.PHONY: tarball
tarball:
	$(MAKE) distclean
	$(MAKE) check-submods check_all_committed drbd/.drbd_git_revision
	$(MAKE) .filelist
	$(MAKE) tgz

module .filelist: drbd/.drbd_git_revision

ifdef RPMBUILD

# kernel module package using the system macros.
# result is kABI aware and uses the weak-updates mechanism.
# Only define %kernel_version, it it was set outside of this file,
# i.e. was inherited from environment, or set explicitly on command line.
# If unset, the macro will figure it out internally, and not depend on
# uname -r, which may be wrong in a chroot build environment.
.PHONY: kmp-rpm
kmp-rpm: tgz drbd-kernel.spec
	cp drbd-$(FDIST_VERSION).tar.gz `rpm -E "%_sourcedir"`
	KVER=$(KVER); flavors=; \
	case $$KVER in *.debug) flavors=debug; KVER=$${KVER%.debug};; esac; \
	$(RPMBUILD) -bb \
	    $(if $(filter file,$(origin KVER)), --define "kernel_version $$KVER") \
	    $${flavors:+ --define "lb_flavors $$flavors"} \
	    $(RPMOPT) \
	    drbd-kernel.spec
	@echo "You have now:" ; find `rpm -E "%_rpmdir"` -name *.rpm

.PHONY: srpm
srpm: tgz
	cp drbd-$(FDIST_VERSION).tar.gz `rpm -E "%_sourcedir"`
	$(RPMBUILD) -bs \
	    --define "kernelversion $(KVER)" \
	    --define "kernel_version $(KVER)" \
	    --define "kdir $(KDIR)" \
		$(RPMOPT) \
		drbd-kernel.spec
	@echo "You have now:" ; find `rpm -E "%_srcrpmdir"` -name *.src.rpm
endif

ifdef DEBBUILD
.PHONY: km-deb
km-deb: check-submods distclean drbd/.drbd_git_revision
	D=$$(mktemp -p . -d); 					\
	( git ls-files --recurse-submodules ;			\
	  echo drbd/.drbd_git_revision ) | cpio -pvmd "$$D" ;	\
	( cd "$$D" && $(DEBBUILD) -i -us -uc -b ) && rm -rf "$$D"
endif

.PHONY: dockerimage.rhel7 dockerimage.rhel8 dockerimage.bionic dockerimage.focal dockerimage.sles15sp1 dockerimage
dockerimage.rhel7:
	cd docker && docker build -f Dockerfile.centos7 -t $(DOCKERREGPATH_RHEL7):$(TAG) $(EXTRA_DOCKER_BUILDARGS) .
	docker tag $(DOCKERREGPATH_RHEL7):$(TAG) $(DOCKERREGPATH_RHEL7):latest

dockerimage.rhel8:
	cd docker && docker build -f Dockerfile.centos8 -t $(DOCKERREGPATH_RHEL8):$(TAG) $(EXTRA_DOCKER_BUILDARGS) .
	docker tag $(DOCKERREGPATH_RHEL8):$(TAG) $(DOCKERREGPATH_RHEL8):latest

dockerimage.bionic:
	cd docker && docker build -f Dockerfile.bionic -t $(DOCKERREGPATH_BIONIC):$(TAG) $(EXTRA_DOCKER_BUILDARGS) .
	docker tag $(DOCKERREGPATH_BIONIC):$(TAG) $(DOCKERREGPATH_BIONIC):latest

dockerimage.focal:
	cd docker && docker build -f Dockerfile.focal -t $(DOCKERREGPATH_FOCAL):$(TAG) $(EXTRA_DOCKER_BUILDARGS) .
	docker tag $(DOCKERREGPATH_FOCAL):$(TAG) $(DOCKERREGPATH_FOCAL):latest

dockerimage.sles15sp1:
	cd docker && docker build -f Dockerfile.sles15sp1 -t $(DOCKERREGPATH_SLES15SP1):$(TAG) $(EXTRA_DOCKER_BUILDARGS) .
	docker tag $(DOCKERREGPATH_SLES15SP1):$(TAG) $(DOCKERREGPATH_SLES15SP1):latest

dockerimage: dockerimage.rhel7 dockerimage.rhel8 dockerimage.bionic dockerimage.focal dockerimage.sles15sp1

# used for --sync in lbbuild to decide which containers to push to which registry
dockerpath:
	@echo $(DOCKERREGPATH_BIONIC):$(TAG) $(DOCKERREGPATH_BIONIC):latest \
		$(DOCKERREGPATH_FOCAL):$(TAG) $(DOCKERREGPATH_FOCAL):latest \
		$(DOCKERREGPATH_RHEL7):$(TAG) $(DOCKERREGPATH_RHEL7):latest \
		$(DOCKERREGPATH_RHEL8):$(TAG) $(DOCKERREGPATH_RHEL8):latest \
		$(DOCKERREGPATH_SLES15SP1):$(TAG) $(DOCKERREGPATH_SLES15SP1):latest

ifndef MODE
MODE = report
endif

.PHONY: coccicheck

=== drbd/Makefile ===
# makefile for drbd for linux 2.4 // 2.6
#
# By Lars Ellenberg.
#
# drbd is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# drbd is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with drbd; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#

# usage: make [ KDIR=/path/to/kernel/source ]
#
# this file is read twice:
# the first invocation calls out to the toplevel Makefile in the
# kernel source tree, which then in turn will call this file again
# as subdir Makefile, with all appropriate vars and macros set.
#
# note: if you get strange make errors when ARCH=um, you
# probably need to "make mrproper" in the KDIR first...

# The destination "root" directory. Meant to be overridden by
# packaging scripts.
DESTDIR ?= /

# Do not:
# o  use make's built-in rules and variables
#    (this increases performance and avoids hard-to-debug behaviour);
# o  print "Entering directory ...";
MAKEFLAGS += -rR --no-print-directory

# Use the SPAAS (spatch as a service) online service
# Have this as make variable for distributions.
SPAAS ?= true
export SPAAS

# since 2.6.16, KERNELRELEASE may be empty,
# e.g. when building against some (broken?) linux-header package.
# Lets test on PATCHLEVEL, that won't change too soon...

ifneq ($(PATCHLEVEL),)
 # suffifiently new kernel will include Kbuild directly
 ifneq ($(VERSION),3)
  ifneq ($(VERSION),2)
    $(error "won't compile with this kernel version")
  endif
  ifneq ($(PATCHLEVEL),6)
    $(error "won't compile with this kernel version")
  endif
 endif

  CONFIG_BLK_DEV_DRBD := m

  include $(src)/Kbuild

else
  # called from command line in current directory

  # for some reason some of the commands below only work correctly in bash,
  # and not in e.g. dash. I'm too lazy to fix it to be compatible.
  SHELL=/bin/bash

  DRBDSRC := $(shell pwd)

  # to be overridden on command line:
  PREFIX := /
  ifneq ($(wildcard ../build-for-uml),)
    #### for Philipp's convenience :)
    ARCH_UM := "ARCH=um"
    KDIR := /usr/src/linux-um
  else
    ifeq ($(wildcard /lib/modules/$(shell uname -r)/source),)
      KDIR := /lib/modules/$(shell uname -r)/build
    else
      KDIR := /lib/modules/$(shell uname -r)/source
      ifneq ("$(origin KDIR)", "command line")
        ifneq ($(wildcard /lib/modules/$(shell uname -r)/build),)
          O := /lib/modules/$(shell uname -r)/build
        endif
      endif
    endif
  endif

  .PHONY: drbd.o default all greeting clean kbuild install dep tags unpatch compat

  drbd.o: greeting kbuild
  default: drbd.o
  all:     drbd.o

  greeting:
	@echo "" ;\
	echo "    Calling toplevel makefile of kernel source tree, which I believe is in" ;\
	echo "    KDIR=$(KDIR)" ; \
	echo "";
	@if ! test -e $(KDIR)/Makefile ; then \
		echo -e "    SORRY, kernel makefile not found. You need to tell me a correct KDIR!\n" ;\
		false;\
	fi

  unpatch:
	@if test -e .compat_patches_applied; then \
	    echo "Removing compat patches"; \
	    patch -R -p0 --batch < .compat_patches_applied; \
	    rm -f .compat_patches_applied; \
	fi

  .PHONY: test-compile
  test-compile:
	$(MAKE)
	$(MAKE) unpatch

  # compat.h is built by Kbuild; I think the most easy way to trigger that
  # without trying to re-implement all the Kbuild magic badly, is to simply
  # tell it to compile our smallest, least complex .c file which still
  # has a dependency on our compat.h
  .PHONY: compat.h
  compat.h:
	@touch dummy-for-compat-h.c
	@mkdir .tmp_versions
	$(MAKE) -C $(KDIR)  $(if $(O),O=$(O),) M=$(DRBDSRC) $(ARCH_UM) obj-m=dummy-for-compat-h.o dummy-for-compat-h.o

  kbuild: fix-tar-timestamps
	@rm -f .drbd_kernelrelease*
	$(MAKE) -C $(KDIR)  $(if $(O),O=$(O),) M=$(DRBDSRC) $(ARCH_UM) modules
	-mv .drbd_kernelrelease.new .drbd_kernelrelease
	@echo -n "Memorizing module configuration ... "
	@config=$$( (for x in $(KDIR)/.config $(O)/.config ; do \
	       if test -e $$x ; then echo $$x ; exit 0; fi ; \
	       done; echo $(KDIR)/.config) | sed -e 's,//,/,g') ; \
	{ echo -e "#\n# drbd.o was compiled with"          ; \
	  echo "#  `gcc -v 2>&1 | tail -1`"                 ; \
	  echo "# against this kernelrelease:"              ; \
	  sed 's/^/#  /' .drbd_kernelrelease                ; \
	  echo    "# kernel .config from"                   ; \
	  echo -n "#  $$config"                      ; \
	  test -L "$${config%/.config}" && echo "	alias"   &&           \
	  echo "#  $$(readlink $${config%/.config})/.config" || echo "" ; \
	  echo -e "# follows\n#\n"                          ; \
	  cat $$config ; } | gzip > .kernel.config.gz
	@echo "done."

  clean: unpatch
	rm -rf .tmp_versions Module.markers Module.symvers modules.order
	rm -f *.[oas] *.ko .*.cmd .*.d .*.tmp *.mod.c .*.flags .depend .kernel*
	rm -f dummy-for-compat-h.c
	rm -f drbd-kernel-compat/*.[oas] drbd-kernel-compat/.*.cmd
	rm -f drbd-kernel-compat/compat.patch drbd-kernel-compat/.compat.cocci
	rm -f .timestamps_fixed
	rm -rf .compat_test.* .cache.mk

  distclean: clean
	rm -f drbd_buildtag.c .config*.timestamp compat*.h

  tags:
	( git ls-files ;						\
	  git submodule foreach -q --recursive				\
		'git ls-files | sed -e "s,^,$$displaypath/,"' ) |	\
		ctags -L -						\
		-I __initdata,__exitdata,__acquires,__releases		\
		-I __must_hold,__protected_by,__protected_read_by	\
		-I __protected_write_by,BIO_ENDIO_ARGS

  compat_headers := $(wildcard drbd-kernel-compat/cocci_cache/*/compat.h)
  compat_patches := $(patsubst %.h,%.patch,$(compat_headers))

  sources := $(filter-out drbd_strings.c drbd_buildtag.c,$(wildcard *.c))
  sources += $(wildcard drbd-headers/linux/*.h)

  $(compat_patches): $(sources)
	@. ./drbd-kernel-compat/gen_compat_patch.sh $@ $^

  compat: $(compat_patches)

  ifneq ($(wildcard .drbd_kernelrelease),)
    # for VERSION, PATCHLEVEL, SUBLEVEL, EXTRAVERSION, KERNELRELEASE
    include .drbd_kernelrelease
    MODOBJS := drbd.ko drbd_transport_tcp.ko
    MODSUBDIR := updates
    LINUX := $(wildcard /lib/modules/$(KERNELRELEASE)/build)

    install:
	@if ! [ -e $(MODOBJ) ] ; then \
	  echo "No $(MODOBJ): nothing to install??"; false ; \
	fi
	install -d $(DESTDIR)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR)
	set -e ; for ko in $(MODOBJS); do \
		install -m 644 $$ko $(DESTDIR)/lib/modules/$(KERNELRELEASE)/$(MODSUBDIR); \
	done
    ifeq ($(DESTDIR),/)
      ifeq ($(shell uname -r),$(KERNELRELEASE))
		/sbin/depmod -a || :
      else
		@echo "Don't forget to depmod."
      endif
    endif
  else
    install:
	@echo "No .drbd_kernelrelease found. Do you need to 'make' the module first?"
	@false
  endif
endif

.PHONY: fix-tar-timestamps
fix-tar-timestamps:
	@-test -e ../.git || test -e .timestamps_fixed || \
	touch drbd-kernel-compat/cocci_cache/*/compat.patch .timestamps_fixed

uninstall:

spell:
	for f in $(wildcard *.c); do \
	 	aspell --save-repl --dont-backup --personal=./../documentation/aspell.en.per check $$f; \
	done

=== debian/changelog ===
drbd (9.0.31-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue,  5 Oct 2021 08:37:02 +0100

drbd (9.0.30-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Wed, 14 Jul 2021 10:43:09 +0100

drbd (9.0.29-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Thu,  6 May 2021 09:39:07 +0100

drbd (9.0.28-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Thu, 25 Feb 2021 17:18:21 +0100

drbd (9.0.27-1) unstable; urgency=low

  * New upstream release
  * Fix regression: allow live migration between two diskful peers again

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Wed, 23 Dec 2020 11:51:29 +0100

drbd (9.0.26-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue, 22 Dec 2020 09:13:54 +0100

drbd (9.0.25-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue, 22 Sep 2020 14:14:47 +0100

drbd (9.0.24-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 29 Jun 2020 16:15:19 +0100

drbd (9.0.23-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 08 Jun 2020 15:53:56 +0100

drbd (9.0.22-2) unstable; urgency=low

  * Fix reads on diskless in the presence of IO errors
  * Fix diskless nodes leaving a quorum enabled cluster

 -- Philipp Reisner <phil@linbit.com>  Mon, 30 Mar 2020 12:03:10 +0100

drbd (9.0.22-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Tue, 10 Mar 2020 15:34:09 +0100

drbd (9.0.21-1) unstable; urgency=low

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 12 Nov 2019 13:10:11 +0100

drbd (9.0.20-2) unstable; urgency=medium

  * New Debian release

 -- Roland Kammerer <roland.kammerer@linbit.com>  Fri, 11 Oct 2019 14:14:18 +0200

drbd (9.0.20-1) unstable; urgency=medium

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Thu, 10 Oct 2019 09:12:38 +0200

drbd (9.0.19-1) unstable; urgency=medium

  * New upstream release

 -- Philipp Reisner <phil@linbit.com>  Mon, 08 Jul 2019 16:23:16 +0200

drbd (9.0.18.1-1) unstable; urgency=medium

  * New upstream release

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Fri, 31 May 2019 11:37:53 +0200

drbd (9.0.18-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 24 May 2019 11:56:17 +0200

drbd (9.0.17-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 26 Mar 2019 16:48:22 +0100

drbd (9.0.16-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 25 Oct 2018 11:12:29 +0100

drbd (9.0.15-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 14 Aug 2018 13:03:34 +0100

drbd (9.0.14-1) unstable; urgency=medium

  * New upstream release.

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Tue, 01 May 2018 00:12:39 +0200

drbd (9.0.13-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 17 Apr 2018 10:30:07 +0100

drbd (9.0.12-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Mon, 22 Jan 2018 13:24:51 +0100

drbd (9.0.11-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Kammerer <roland.kammerer@linbit.com>  Tue, 09 Jan 2018 13:13:07 +0100

drbd (9.0.10-1) unstable; urgency=low

  * New upstream release.

 -- Roland Kammerer <rolan.kammerer@linbit.com>  Fri, 22 Dec 2017 13:02:11 +0100

drbd (9.0.9-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 31 Aug 2017 10:44:00 +0800

drbd (9.0.8-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Mon, 19 Jun 2017 15:27:42 +0800

drbd (9.0.7-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 31 Mar 2017 16:13:06 +0100

drbd (9.0.6-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 23 Dec 2016 13:02:18 +0100

drbd (9.0.5-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 20 Oct 2016 14:41:41 +0100

drbd (9.0.4-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 06 Sep 2016 15:36:13 +0100

drbd (9.0.3-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu, 14 Jul 2016 10:31:15 +0100

drbd (9.0.2-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 19 Apr 2016 15:38:10 +0100

drbd (9.0.1-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 02 Feb 2016 16:39:11 +0100

drbd (9.0.0-3) unstable; urgency=low

  * Fixes for the RDMA transport
  * Fixes for 8.4 compatibility
  * Rebuild after compat and build system fixes

 -- Lars Ellenberg <lars.ellenberg@linbit.com>  Tue, 28 Jul 2015 17:22:34 +0200

drbd (9.0.0-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 16 Jun 2015 13:53:29 +0200

drbd (9.0.0rc3-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Wed, 13 May 2015 13:19:33 +0200

drbd (9.0.0rc2-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Thu,  6 Mar 2015 11:29:00 +0200

drbd (9.0.0rc1-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Tue, 20 Jan 2015 14:00:00 +0200

drbd (9.0.0pre10-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri, 19 Sep 2014 21:26:13 +0200

drbd (9.0.0pre9-1) unstable; urgency=low

  * New upstream release.

 -- Philipp Reisner <phil@linbit.com>  Fri,  7 Mar 2014 17:31:00 +0200

=== debian/control ===
Source: drbd
Section: admin
Priority: extra
Maintainer: DRBD dev <drbd-dev@lists.linbit.com>
Uploaders: Philipp Reisner <phil@linbit.com>,
           Lars Ellenberg <lars@linbit.com>,
           Roland Kammerer <roland.kammerer@linbit.com>
Build-Depends: bash,
               debhelper (>= 7),
               dkms
Standards-Version: 3.6.2.1

Package: drbd-dkms
Architecture: all
Section: admin
Depends: debhelper (>=7),
         dkms (>= 1.9.5),
         drbd-utils (>= 9.2.0),
         curl,
         ${misc:Depends}
Conflicts: drbd-module-source,
           drbd8-module-source
Provides: drbd-dkms
Replaces: drbd-module-source
Description: RAID 1 over TCP/IP for Linux module source
 DRBD is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the source code for the DRBD kernel module.
Homepage: http://www.drbd.org

Package: drbd-module-source
Architecture: all
Section: admin
Depends: debhelper (>= 7),
         ${misc:Depends}
Conflicts: drbd-dkms,
           drbd8-module-source
Provides: drbd-module-source
Replaces: drbd-dkms
Recommends: kernel-package | module-assistant
Description: RAID 1 over TCP/IP for Linux module source
 DRBD is a block device which is designed to build high availability
 clusters by providing a virtual shared device which keeps disks in
 nodes synchronised using TCP/IP. This simulates RAID 1 but avoiding
 the use of uncommon hardware (shared SCSI buses or Fibre Channel).
 It is currently limited to fail-over HA clusters.
 .
 This package contains the source code for the DRBD kernel module.
Homepage: http://www.drbd.org

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

VERSION := $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9]+:)?//p')
PACKAGE=drbd-module
DKMSDIR=drbd-dkms
MODSRCDIR=drbd-module-source

# modifieable for experiments or debugging m-a
MA_DIR ?= /usr/share/modass
# load generic variable handling
-include $(MA_DIR)/include/generic.make
# load default rules, including kdist, kdist_image, ...
-include $(MA_DIR)/include/common-rules.make

%:
	dh $@ --with dkms

override_dh_auto_clean: ;
override_dh_auto_configure: ;
override_dh_auto_build: ;
override_dh_auto_test: ;
override_dh_auto_install: ;

override_dh_install:
	# dkms
	dh_install drbd ../$(DKMSDIR)/usr/src/drbd-$(VERSION)/src

	# m-a
	dh_install drbd ../$(MODSRCDIR)/usr/src/modules/drbd/
	dh_install misc/SECURE-BOOT-KEY-linbit.com.der ../$(MODSRCDIR)/usr/src/modules/drbd/misc
	dh_install debian/changelog ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/control ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/compat ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/copyright ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/*modules.in ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	dh_install debian/rules ../$(MODSRCDIR)/usr/src/modules/drbd/debian
	cd debian/$(MODSRCDIR)/usr/src ; tar pzfvc drbd.tar.gz modules ; rm -rf modules
	install -m 755 debian/modass.drbd-module-source ./debian/$(MODSRCDIR)/usr/share/modass/overrides/$(MODSRCDIR)

override_dh_dkms:
	dh_dkms -V $(VERSION)

# some nasty clue code for m-a
kdist_clean:
	dh_clean
	-$(MAKE) -C drbd clean

DEB_BUILD_ARCH := $(shell dpkg --print-architecture)
binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_clean -k
	$(MAKE) -C drbd KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) KDIR=$(KSRC)
	$(MAKE) -C $(KSRC) M=$(CURDIR)/drbd modules_install INSTALL_MOD_PATH=$(CURDIR)/debian/$(PKGNAME) INSTALL_MOD_DIR=updates CONFIG_MODULE_SIG_ALL=y CONFIG_MODULE_SIG_KEY=certs/signing_key.pem
	install -m644 -b -D misc/SECURE-BOOT-KEY-linbit.com.der $(CURDIR)/debian/$(PKGNAME)/etc/pki/linbit/SECURE-BOOT-KEY-linbit.com.der
	install -m644 -b -D drbd/Module.symvers $(DEB_DESTDIR)/Module.symvers.$(KVERS).$(DEB_BUILD_ARCH)
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

=== debian/watch ===
version=3

opts=dversionmangle=s/\+linbit\d*$// \
http://plain.oss.linbit.com/drbd/9.0/drbd-(.+)\.tar\.gz
